﻿using System;
using System.Linq;
using System.Collections.Generic;
using DataVirtualization;
using WPFTestApp.Data;


namespace WPFTestApp
{
    public class CustomerProvider : IItemsProvider<Customer>
    {
        private int count;
        public int GetTotal()
        {
            using (var context = new ModelEntities())
            {
                count = context.Customer.Count();
            }
            return count;
        }

        public IList<Customer> GetList(int startIndex, int pageCount, out int overallCount)
        {
            overallCount = count;
            IList<Customer> list = null;
            using (var context = new ModelEntities())
            {
                list = context.Customer.Where(c => c.RowID >= startIndex + 1 && c.RowID < (startIndex + 1 + pageCount)).ToList();
            }
            return list;
        }
    }
}
