﻿using System;
using System.Windows;
using DataVirtualization;
using WPFTestApp.Data;
using Infragistics.Windows.DataPresenter.Events;
using System.ComponentModel;
using PrestImmo.Modules.DataService.Managers.Base;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using Infragistics.Documents.Excel;

namespace WPFTestApp
{
    /// <summary>
    /// Interaction logic for WindowXamDataGrid.xaml
    /// </summary>
    public partial class WindowXamDataGrid : Window
    {
        private CustomerProvider customerProvider;
        private IQuery<Customer> customerQuery;

        public WindowXamDataGrid()
        {
            InitializeComponent();

            customerProvider = new CustomerProvider();
            //AsyncVirtualizingCollection<Customer> customerList = new AsyncVirtualizingCollection<Customer>(customerProvider, 100 /*page size*/, 3000 /*timeout*/);
            //this.DataContext = customerList;

            customerQuery = new GenericQuery<Customer>();
            Customers = new AsyncVirtualizingCollection<Customer>(customerQuery, 100, 300);
            this.DataContext = this;
        }

        protected AsyncVirtualizingCollection<Customer> customers;
        public AsyncVirtualizingCollection<Customer> Customers
        {
            get { return customers; }
            protected set
            {
                customers = value;
                this.OnPropertyChanged("Customers");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }
        }

        #endregion

        private void XamDataGrid1_RecordFilterChanging(object sender, RecordFilterChangingEventArgs e)
        {
            e.Handled = true;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //DataPresenterExcelExporter exporter = (DataPresenterExcelExporter)this.Resources["Exporter"];
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            exporter.Export(this.XamDataGrid1, @"f:\test.xlsx", WorkbookFormat.Excel2007);
        }
    }
}
